# -*- coding: utf-8 -*-

"""Python wrapper for XBEL Files
created 27/03/2006 By Nicolas Laurance
based on the Mark Pilgrim's API http://www.sifry.com/alerts/archives/000288.html
"""
__author__ = "Nicolas Laurance <nlaurance@zindep.com>"
__version__ = "0.1"
__date__ = "$Date: 2003/06/27 22:40:53 $"[7:-2]
__copyright__ = "Copyright (c) 2006 Nicolas Laurance"
__license__ = "Python"

from xml.dom import minidom
import re

DEBUG = 0

class Bag: pass

_intFields = ('')
_dateFields = ('added','modified','visited')
_listFields = ('info',)
_floatFields = ('')

def unmarshal(element):
    rc = Bag()
    #import pdb;pdb.set_trace()
    try:
        if element.hasAttributes():
            for key in element.attributes.keys():
                value=element.attributes[str(key)].nodeValue
                if str(key) in _dateFields:
                    year, month, day, hour, minute, second = re.search(r'(\d{4})-(\d{2})-(\d{2}) (\d{2}):(\d{2}):(\d{2})', value).groups()
                    value = (int(year), int(month), int(day), int(hour), int(minute), int(second), 0, 0, 0)
                setattr(rc, str(key), value)
    except:
        pass
    childElements = [e for e in element.childNodes if isinstance(e, minidom.Element)]
    if childElements:
        for child in childElements:
            key = child.tagName
            if DEBUG: print '%s ' % (key,)
# take care of special tag names here
            if child.tagName in ('folder','bookmark','separator'):
                if hasattr(rc, 'sub'):
                    setattr(rc, 'sub', getattr(rc, 'sub') + [unmarshal(child)])
                else:
                    setattr(rc, 'sub', [unmarshal(child)])
            elif hasattr(rc, key):
                setattr(rc, key, getattr(rc, key) + [unmarshal(child)])
            elif key in _listFields:
                setattr(rc, key, [unmarshal(child)])
            else:
                setattr(rc, key, unmarshal(child))
    else:
        PCDATA = "".join([e.data for e in element.childNodes if isinstance(e, minidom.Text)])
        if str(element.tagName) in _intFields:
            return int(PCDATA)
            if DEBUG: print '%s : %s' % (element.tagName,rc)
        elif str(element.tagName) in _floatFields:
            return float(PCDATA)
            if DEBUG: print '%s : %s' % (element.tagName,rc)
        elif str(element.tagName) in _dateFields:
            year, month, day, hour, minute, second = re.search(r'(\d{4})-(\d{2})-(\d{2}) (\d{2}):(\d{2}):(\d{2})', PCDATA).groups()
            return (int(year), int(month), int(day), int(hour), int(minute), int(second), 0, 0, 0)
            if DEBUG: print '%s : %s' % (element.tagName,rc)
        if PCDATA:
            return PCDATA
# data.xbel.sub[0].sub[0].info[0].metadata
    return rc

def _do(rawdata):
    """
    processes xbel file, returns None if there is a problem
    bad XML or non xbel
    """
    try:
        xmldoc = minidom.parseString(rawdata)
        data = unmarshal(xmldoc)
        return data.xbel
    except:
        return None

def test():
    f=open('xbel.xml','r')
    r=_do(f.read())
    f.close()
    return r

def main():
    from timeit import Timer
    t = Timer("test()", "from __main__ import test")
    print "%.2f usec/pass" % t.timeit(number=1000)

if __name__ == "__main__":
    main()
